## wxpython4.0 4.0.7+dfsg

=== wscript ===
#!/usr/bin/python
#-----------------------------------------------------------------------------
#  WAF script for building and installing the wxPython extension modules.
#
# Author:      Robin Dunn
# Copyright:   (c) 2013 - 2018 by Total Control Software
# License:     wxWindows License
#-----------------------------------------------------------------------------

import sys
import os

try:
    from textwrap import indent
except ImportError:
    from buildtools.backports.textwrap3 import indent

from buildtools.config import Config, runcmd, msg
cfg = Config(True)

#-----------------------------------------------------------------------------
# Options and configuration

APPNAME = 'wxPython'
VERSION = cfg.VERSION

isWindows = sys.platform.startswith('win')
isDarwin = sys.platform == "darwin"

top = '.'
out = 'build/waf'


def options(opt):
    if isWindows:
        opt.load('msvc')
    else:
        opt.load('compiler_c compiler_cxx')
    opt.load('python')

    opt.add_option('--debug', dest='debug', action='store_true', default=False,
                   help='Turn on debugger-related compile options.')
    opt.add_option('--python', dest='python', default='', action='store',
                   help='Full path to the Python executable to use.')
    opt.add_option('--wx_config', dest='wx_config', default='wx-config', action='store',
                   help='Full path to the wx-config script to be used for this build.')
    opt.add_option('--no_magic', dest='no_magic', action='store_true', default=False,
                   help='Don\'t use linker magic to enable wx libs to be bundled with '
                   'wxPython.  See build.py for more info.')
    opt.add_option('--mac_arch', dest='mac_arch', default='', action='store',
                   help='One or more comma separated architecture names to be used for '
                   'the Mac builds. Should be at least a subset of the architectures '
                   'used by wxWidgets and Python')
    opt.add_option('--gtk2', dest='gtk2', action='store_true', default=False,
                   help='On Linux build for gtk2 (default gtk3)')
    opt.add_option('--gtk3', dest='gtk3', action='store_true', default=True,
                   help='On Linux build for gtk3')
    opt.add_option('--msvc_arch', dest='msvc_arch', default='x86', action='store',
                   help='The architecture to target for MSVC builds. Supported values '
                   'are: "x86" or "x64"')
    opt.add_option('--msvc_relwithdebug', dest='msvc_relwithdebug', action='store_true', default=False,
                   help='Turn on debug info for release builds for MSVC builds.')



def configure(conf):
    if isWindows:
        # For now simply choose the compiler version based on the Python
        # version. We have a chicken-egg problem here. The compiler needs to
        # be selected before the Python stuff can be configured, but we need
        # Python to know what version of the compiler to use.
        import distutils.msvc9compiler
        msvc_version = str( distutils.msvc9compiler.get_build_version() )

        # When building for Python 3.7 the msvc_version returned will be
        # "14.1" as that is the version of the BasePlatformToolkit that stock
        # Python 3.7 was built with, a.k.a v141, which is the default in
        # Visual Studio 2017. However, waf is using "msvc 15.0" to designate
        # that version rather than "14.1" so we'll need to catch that case and
        # fix up the msvc_version accordingly.
        if msvc_version == "14.1" and sys.version_info >= (3,7):
            ##msvc_version = '15.0'

            # On the other hand, microsoft says that v141 and v140 (Visual
            # Studio 2015) are binary compatible, so for now let's just drop
            # it back to "14.0" until I get all the details worked out for
            # using VS 2017 everywhere for Python 3.7+.
            msvc_version = '14.0'

        # In some cases (Azure DevOps at least) we're getting "14.1" for Python
        # 3.6 too. Smash it down to '14.0'
        if msvc_version == "14.1" and sys.version_info[:2] == (3,6):
            msvc_version = '14.0'

        conf.env['MSVC_VERSIONS'] = ['msvc ' + msvc_version]
        conf.env['MSVC_TARGETS'] = [conf.options.msvc_arch]
        conf.load('msvc')
    else:
        conf.load('compiler_c compiler_cxx')

    if conf.options.python:
        conf.env.PYTHON = conf.options.python
    conf.load('python')
    conf.check_python_version(minver=(2,7,0))
    if isWindows:
        # Search for the Python headers without doing some stuff that could
        # incorrectly fail on Windows. See my_check_python_headers below.
        # TODO: Check if it can/should be used on other platforms too.
        conf.my_check_python_headers()
    else:
        conf.check_python_headers(features='pyext')

    # fetch and save the debug options
    conf.env.debug = conf.options.debug
    conf.env.msvc_relwithdebug = conf.options.msvc_relwithdebug

    # Ensure that the headers in siplib and Phoenix's src dir can be found
    conf.env.INCLUDES_WXPY = ['sip/siplib', 'wx/include', 'src']

    if isWindows:
        # Windows/MSVC specific stuff

        cfg.finishSetup(debug=conf.env.debug)

        conf.env.INCLUDES_WX = cfg.includes
        conf.env.DEFINES_WX = cfg.wafDefines
        conf.env.CFLAGS_WX = cfg.cflags
        conf.env.CXXFLAGS_WX = cfg.cflags
        conf.env.LIBPATH_WX = cfg.libdirs
        conf.env.LIB_WX = cfg.libs
        conf.env.LIBFLAGS_WX = cfg.lflags

        _copyEnvGroup(conf.env, '_WX', '_WXADV')
        conf.env.LIB_WXADV += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXSTC')
        conf.env.LIB_WXSTC += cfg.makeLibName('stc')

        _copyEnvGroup(conf.env, '_WX', '_WXHTML')
        conf.env.LIB_WXHTML += cfg.makeLibName('html')

        _copyEnvGroup(conf.env, '_WX', '_WXGL')
        conf.env.LIB_WXGL += cfg.makeLibName('gl')

        _copyEnvGroup(conf.env, '_WX', '_WXWEBVIEW')
        conf.env.LIB_WXWEBVIEW += cfg.makeLibName('webview')

        _copyEnvGroup(conf.env, '_WX', '_WXXML')
        conf.env.LIB_WXXML += cfg.makeLibName('xml', isMSWBase=True)

        _copyEnvGroup(conf.env, '_WX', '_WXXRC')
        conf.env.LIB_WXXRC += cfg.makeLibName('xrc')

        _copyEnvGroup(conf.env, '_WX', '_WXRICHTEXT')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('richtext')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXMEDIA')
        conf.env.LIB_WXMEDIA += cfg.makeLibName('media')

        _copyEnvGroup(conf.env, '_WX', '_WXRIBBON')
        conf.env.LIB_WXRIBBON += cfg.makeLibName('ribbon')

        _copyEnvGroup(conf.env, '_WX', '_WXPROPGRID')
        conf.env.LIB_WXPROPGRID += cfg.makeLibName('propgrid')

        _copyEnvGroup(conf.env, '_WX', '_WXAUI')
        conf.env.LIB_WXAUI += cfg.makeLibName('aui')

        # ** Add code for new modules here (and below for non-MSW)


        # tweak the PYEXT compile and link flags if making a --debug build
        if conf.env.debug:
            for listname in ['CFLAGS_PYEXT', 'CXXFLAGS_PYEXT']:
                lst = conf.env[listname]
                for opt in '/Ox /MD /DNDEBUG'.split():
                    try:
                        lst.remove(opt)
                    except ValueError:
                        pass
                # NOTE: For --debug builds the /Z7 flag is used so the debug
                # info will be in each object file instead of a separate PDB
                # file. This will result in much faster builds since VC won't
                # have to serialize access to the .pdb file. OTOH, separate
                # PDB files are generated for the --msvc_relwithdebug option,
                # which is handled below in the makeETGRule() function.
                lst[1:1] = '/Od /MDd /Z7 /D_DEBUG'.split()

            conf.env['LINKFLAGS_PYEXT'].append('/DEBUG')
            conf.env['LIB_PYEXT'][0] += '_d'


    else:
        # TODO: Double-check that this works when using an installed wxWidgets
        wxConfigDir = cfg.findWxConfigDir(conf.options.wx_config)

        # Configuration stuff for non-Windows ports using wx-config
        conf.env.CFLAGS_WX   = list()
        conf.env.CXXFLAGS_WX = list()
        conf.env.CFLAGS_WXPY   = list()
        conf.env.CXXFLAGS_WXPY = list()

        # finish configuring the Config object
        conf.env.wx_config = conf.options.wx_config
        cfg.finishSetup(conf.env.wx_config, conf.env.debug)

        # Check wx-config exists and fetch some values from it
        rpath = ' --no-rpath' if not conf.options.no_magic else ''
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs core,net' + rpath,
                       uselib_store='WX', mandatory=True,
                       msg='Finding libs for WX')

        # Run it again with different libs options to get different
        # sets of flags stored to use with varous extension modules below.
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs adv,core,net' + rpath,
                       uselib_store='WXADV', mandatory=True,
                       msg='Finding libs for WXADV')

        libname = '' if cfg.MONOLITHIC else 'stc,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args=('--cxxflags --libs %score,net' % libname) + rpath,
                       uselib_store='WXSTC', mandatory=True,
                       msg='Finding libs for WXSTC')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs html,core,net' + rpath,
                       uselib_store='WXHTML', mandatory=True,
                       msg='Finding libs for WXHTML')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_GLCANVAS'):
            gl_libs = '--libs gl,core,net'
        else:
            gl_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + gl_libs + rpath,
                       uselib_store='WXGL', mandatory=True,
                       msg='Finding libs for WXGL')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_WEBVIEW'):
            wv_libs = '--libs webview,core,net'
        else:
            wv_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + wv_libs + rpath,
                       uselib_store='WXWEBVIEW', mandatory=True,
                       msg='Finding libs for WXWEBVIEW')

        if isDarwin:
            conf.check_cfg(path=conf.options.wx_config, package='',
                           args='--cxxflags --libs core,net' + rpath,
                           uselib_store='WXWEBKIT', mandatory=True,
                           msg='Finding libs for WXWEBKIT')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xml,core,net' + rpath,
                       uselib_store='WXXML', mandatory=True,
                       msg='Finding libs for WXXML')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xrc,xml,core,net' + rpath,
                       uselib_store='WXXRC', mandatory=True,
                       msg='Finding libs for WXXRC')

        libname = '' if cfg.MONOLITHIC else 'richtext,adv,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs %score,net' % libname + rpath,
                       uselib_store='WXRICHTEXT', mandatory=True,
                       msg='Finding libs for WXRICHTEXT')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_MEDIACTRL'):
            mc_libs = '--libs media,core,net'
        else:
            mc_libs = '--libs core,net'

=== ext/wxWidgets/locale/Makefile ===
# this is the makefile for generating wxstd.pot message catalog file and
# building lang.mo files from the translated lang.po catalogs

# this makefile may be invoked to build either wxstd.pot or any lang.mo

# Autodetect the languages we support.  Currently this relies on make
# being called with this dir as the cwd, but if we generate this file
# with configure an explicit path should be specified -- RL.

WX_LINGUAS := $(shell ls *.po */*.po 2> /dev/null | sed 's/wxstd.pot//g' | sed 's/.po//g')
WX_LINGUAS_UPDATE := $(shell ls *.po 2> /dev/null | sed 's/wxstd.pot//g' | sed 's/.po//g')

# the programs we use (TODO: use configure to detect them)
MSGFMT=msgfmt --verbose
MSGMERGE=msgmerge
XGETTEXT=xgettext
XARGS=xargs

# common xgettext args: C++ syntax, use the specified macro names as markers
XGETTEXT_ARGS=-C -k_ -kwxPLURAL:1,2 -kwxTRANSLATE -kwxGetTranslation --add-comments=TRANSLATORS: -s -j

# implicit rules
%.mo: %.po
	$(MSGFMT) -c -o $@ $<

# a PO file must be updated from wxstd.pot to include new translations
# (but not manually maintained platform-specific files like msw/it.po)
$(foreach lang,$(WX_LINGUAS_UPDATE),$(lang).po): wxstd.pot

%.po:
	if [ -f $@ ]; then $(MSGMERGE) $@ wxstd.pot > $@.new && mv $@.new $@; else cp wxstd.pot $@; fi

wxstd.pot:
	touch $@
	find ../include -name "*.h" | $(XARGS) $(XGETTEXT) $(XGETTEXT_ARGS) -o wxstd.pot
	find ../src -name "*.cpp" | $(XARGS) $(XGETTEXT) $(XGETTEXT_ARGS) -o wxstd.pot

allpo: force-update
	@-for t in $(WX_LINGUAS_UPDATE); do $(MAKE) $$t.po; done

allmo:
	@for t in $(WX_LINGUAS); do $(MAKE) $$t.mo; done

force-update:
	$(RM) wxstd.pot

check:
	@for t in $(WX_LINGUAS); do \
	    $(MSGFMT) -c -o /dev/null $$t.po 2>/dev/null || echo "$$t.po is BROKEN."; \
	done

# print out the percentage of the translated strings
stats: FORCE
	@for i in $(WX_LINGUAS); do \
		x=`$(MSGFMT) -o /dev/null "$$i.po" 2>&1 | sed -e 's/[,\.]//g' \
			-e 's/\([0-9]\+\) translated messages\?/TR=\1/' \
			-e 's/\([0-9]\+\) fuzzy translations\?/FZ=\1/' \
			-e 's/\([0-9]\+\) untranslated messages\?/UT=\1/'`; \
		TR=0 FZ=0 UT=0; \
		eval $$x; \
		TOTAL=`expr $$TR + $$FZ + $$UT`; \
		echo "$$i.po `expr 100 "*" $$TR / $$TOTAL`% of $$TOTAL strings"; \
	done

FORCE:

.PHONY: allpo allmo force-update percentage FORCE

=== debian/changelog ===
wxpython4.0 (4.0.7+dfsg-6) unstable; urgency=medium

  * Get unittests working again
  * Backport update of InitLocale() to fix test hangs

 -- Scott Talbert <swt@techie.net>  Wed, 15 Jul 2020 11:12:24 -0400

wxpython4.0 (4.0.7+dfsg-5) unstable; urgency=medium

  * Update debhelper-compat to 13
  * Add wxpython-tools subpackage to replace python-wxtools from wxpython3.0

 -- Scott Talbert <swt@techie.net>  Mon, 29 Jun 2020 20:08:58 -0400

wxpython4.0 (4.0.7+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with SIP 4.19.23 (Closes: #963283)
  * Update Standards Version to 4.5.0

 -- Scott Talbert <swt@techie.net>  Sun, 21 Jun 2020 20:47:56 -0400

wxpython4.0 (4.0.7+dfsg-3) unstable; urgency=medium

  * Add missing TreeCtrl SetSpacing / GetSpacing methods

 -- Scott Talbert <swt@techie.net>  Tue, 14 Apr 2020 21:11:48 -0400

wxpython4.0 (4.0.7+dfsg-2) unstable; urgency=medium

  * Fix SyntaxWarnings (Closes: #945052)

 -- Scott Talbert <swt@techie.net>  Sun, 24 Nov 2019 10:25:09 -0500

wxpython4.0 (4.0.7+dfsg-1) unstable; urgency=medium

  * Update to new upstream release 4.0.7
  * d/patches: remove support-pathlib-and-pathlib2.patch -> no longer needed
  * d/patches: update unbundle-sip.patch
  * d/control: Update Standards Version to 4.4.1

 -- Scott Talbert <swt@techie.net>  Tue, 29 Oct 2019 20:42:52 -0400

=== debian/control ===
Source: wxpython4.0
Section: python
Priority: optional
Maintainer: wxWidgets Maintainers <team+wx@tracker.debian.org>
Uploaders: Olly Betts <olly@survex.com>, Scott Talbert <swt@techie.net>
Build-Depends:
    debhelper-compat (= 13),
    dh-python,
    doxygen,
    libgtk-3-dev,
    libwxgtk3.0-gtk3-dev,
    libwxgtk-media3.0-gtk3-dev,
    libwxgtk-webview3.0-gtk3-dev,
    python3-all,
    python3-all-dev,
    python3-numpy,
    python3-pil,
    python3-pypdf2,
    python3-pytest,
    python3-pytest-timeout,
    python3-pytest-xdist,
    python3-requests,
    python3-setuptools,
    python3-sip-dev (>= 4.19.1),
    xauth,
    xvfb,
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
Homepage: https://www.wxpython.org/

Package: python3-wxgtk4.0
Architecture: any
Depends: python3-pil, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, ${sip3:Depends}
Suggests: wx3.0-doc
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to the wxGTK library and the
 wxPython runtime support libraries.  This is the Phoenix reimplementation of
 wxPython.

Package: python3-wxgtk-media4.0
Architecture: any
Depends: python3-wxgtk4.0, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.media)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxMediaCtrl.  This is the Phoenix
 reimplementation of wxPython.

Package: python3-wxgtk-webview4.0
Architecture: any
Depends: python3-wxgtk4.0, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.html2)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxWebView.  This is the Phoenix
 reimplementation of wxPython.

Package: wxpython-tools
Architecture: all
Depends: python3-wxgtk4.0, ${python3:Depends}, ${misc:Depends}
Provides: python-wxtools
Replaces: python-wxtools
Conflicts: python-wxtools
Description: Tools from the wxPython distribution
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides support utilities and common files for wxPython.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

export DOXYGEN=/usr/bin/doxygen
export SIP=/usr/bin/sip
export PYBUILD_SYSTEM=custom
export PYBUILD_BUILD_ARGS_python3=python{version} -u build.py dox touch etg --nodoc sip build_py --use_syswx --gtk3 --extra_waf "-v"
export PYBUILD_CLEAN_ARGS=python{version} build.py clean
export PYBUILD_BEFORE_INSTALL=mkdir -p {destdir}{install_dir}
export PYBUILD_INSTALL_ARGS_python3=python{version} build.py install_py --destdir={destdir} --extra_setup="--install-layout=deb"
SKIP_TESTS='not (display_Tests or glcanvas_Tests or mousemanager_Tests or numdlg_Tests or uiaction_MouseTests or uiaction_KeyboardTests or unichar_Tests or valtext_Tests or test_frameRestore or test_grid_pi)'
export PYBUILD_TEST_ARGS=xvfb-run -a python{version} -m pytest -v --boxed --timeout=60 -k $(SKIP_TESTS) unittests || true
export PYBUILD_DISABLE=configure

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_install:
	dh_install
	# These are packaged in the -media subpackage:
	rm -f debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_media.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/media.py*
	# These are packaged in the -webview subpackage:
	rm -f debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_html2.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/html2.py*

override_dh_python3:
	dh_python3
	dh_sip3
